package com.example.ficherosmemoriaexterna;

import androidx.appcompat.app.AppCompatActivity;

import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

public class MainActivity extends AppCompatActivity {
    public  static  final String FICHERO = "ficheroExterna.txt";
    EditText cuadroTexto;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        cuadroTexto = (EditText)findViewById(R.id.editText);
        Button botonEscribir = (Button) findViewById(R.id.button1);
        Button botonLeer = (Button) findViewById(R.id.button2);
        Button botonEscPublic = (Button) findViewById(R.id.button3);

        // Si pulsamos en el botón escribir en la tarjeta SD.
        botonEscribir.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                escribirFicheroSD();
            }
        });

        // Si pulsamos en el botón leer en la tarjeta SD.
        botonLeer.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                leerFicheroSD();
            }
        });

        // Si pulsamos en el botón escribir en la tarjeta SD público.
        botonEscPublic.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0) {
                escribirFicheroSDPublico();
            }
        });
    }

    private void escribirFicheroSD(){
        try
        {
            String cadena = cuadroTexto.getText().toString();
            String estado = Environment.getExternalStorageState();

            if (estado.equals(Environment.MEDIA_MOUNTED)){
                File file = new File(getExternalFilesDir(null), FICHERO);
                OutputStreamWriter fout =
                        new OutputStreamWriter(
                                new FileOutputStream(file));
                fout.write(cadena);
                fout.close();
                mostrarMensaje("Fichero escrito OK: " + file.getAbsolutePath());
            }
        }
        catch (IOException e)
        {
            String texto = "Error al escribir fichero en la memoria externa: " + e.getMessage();
            Log.e("Ficheros", texto);
            mostrarMensaje(texto);
        }
    }

    private void leerFicheroSD(){
        try
        {
            String linea="";
            String cadena="";
            String estado = Environment.getExternalStorageState();

            if (estado.equals(Environment.MEDIA_MOUNTED)){
                File file = new File(getExternalFilesDir(null), FICHERO);

                BufferedReader br =
                        new BufferedReader(
                                new InputStreamReader(
                                        new FileInputStream(file)));

                while((linea = br.readLine())!=null){
                    cadena += linea + "\n";
                }
                br.close();

                cuadroTexto.setText(cadena);
                mostrarMensaje("Fichero leído OK");
            }

        }
        catch (IOException e)
        {
            String texto = "Error al leer fichero de la memoria externa: " + e.getMessage();
            Log.e("Ficheros", texto);
            mostrarMensaje(texto);
        }
    }

    private void escribirFicheroSDPublico(){
        try
        {
            String cadena = cuadroTexto.getText().toString();
            String estado = Environment.getExternalStorageState();

            if (estado.equals(Environment.MEDIA_MOUNTED)){
                File file = new File(
                        Environment.getExternalStoragePublicDirectory(
                                Environment.DIRECTORY_DOWNLOADS), FICHERO);
                OutputStreamWriter fout =
                        new OutputStreamWriter(
                                new FileOutputStream(file));
                fout.write(cadena);
                fout.close();
                mostrarMensaje("Fichero escrito en Downloads OK");
            }
        }
        catch (IOException e)
        {
            String texto = "Error al escribir fichero  en el directorio Downloads de la memoria externa:" + e.getMessage();
            Log.e("Ficheros", texto);
            mostrarMensaje(texto);
        }
    }

    private void mostrarMensaje(String texto) {
        Toast.makeText(this, texto, Toast.LENGTH_SHORT).show();
    }
}